/* special program to convert an export Archive file
 * to a file which is compatible with DATAdesign engine v3.+
 *
 * we explicitly need the DATAdesign engine for this
 * (c) 2 February 1993 by Joachim Van der Auwera for
 *				  PROGS, PROfessional & Graphical Software
 */
#include "DATAdesign.h"
#include "qdos.h"
#include "stdio.h"
#include "stdlib.h"
#include "string.h"

char _PROG_NAME[] = "DATAdesign convert";
char *_endmsg=NULL;
#define maxlen 8192 	/* max length of temporary buffer */

char filenam[64],destnam[64];	/* filenames to convert */
char temp[maxlen];		/* temporary space for record */
FILE *in;				/* file for input */
int r;

/* set the record */
void writerec()
	{
	short field=1;
	char c, *start, *curr, *place;
	float val;

	DDnewrec(0);
	start=temp;
	while (1) {
		c= *start++;
		if (c=='\"') {
			/* character field */
			place=start;
			curr=start;
			while (c) {
				c= *start++;
				if (c=='\"')
					if (*start!='\"') c=0;
						else start++;
				*curr++=c;
				}
			DDsetline(0, field++, 1, place);
			} else {
			/* numerical field */
			sscanf(--start,"%f",&val);	  /* get the double */
			for(;*start>='.' && *start<='9' ; start++);
			r=DDsetdouble(0, field++, 1, (double)val);
			}
		/* now handle the end of the field */
		if (*start++!=',') break;
		}
	DDimplement(0);
	}

/* set the fieldnames */
void setfields()
	{
	int place=1;			/* current char in temp */
	char name[64], c, *nam; /* place for fieldname */

	nam=name;
	while (1) {
		c= temp[place++];
		if (c!='\"') *nam++=c;
		else if (temp[place]=='\"') { place++; *nam++=c; }
		else {
			*nam='\0';
			if (*(nam-1)=='$') DDaddfield (0, name, (short)2);
				else DDaddfield (0, name, (short)5);
			if (temp[place]!=',') return;
			place+=2; nam=name;
			}
		}
	}

/* actual routine which does the conversion */
void convert()
		{
		int i;
		/* open the file for reading */
		in= fopen (filenam, "r");
		if ( in==NULL ) {
				puts ("ERROR while opening file");
				return;
				}
		/* create the DATAdesign file */
		r=DDnewfile(destnam);
		if (r) { puts ("ERROR on creating new file");
				fclose(in);
				return;
				}
		fgets(temp,maxlen,in);
		setfields();
		/* now convert all the records */
		fgets(temp,maxlen,in);
		while (!feof(in)) {
				writerec();
				fgets(temp,maxlen,in);
				}
		/* close the input file */
		fclose (in);
		/* and save and close the output file */
		r=DDsavefile(0,NULL,NULL,(short)1); 	  /* save with default name */
		if (r) puts("ERROR while saving file");
		DDunusebuffer(0);		  /* stop using default file */
		}

void main()
		{
		if (DDinit()) {    /* initialise DATAdesign engine */
				puts ("DATAdesign engine not found, press a key");
				getc(stdin);
				return;
				}

		puts ("This is the DATAdesign file converter");
		puts ("  To convert Archive export files to DATAdesign files");
		puts ("  which are suitable for DATAdesign v3 and higher");
		while (1)
				{
				puts ("Source filename (enter to end) :");
				gets (filenam);
				if ( !strlen(filenam) ) return;
				puts ("Destination filename (will be overwritten) :");
				gets (destnam);
				puts ("Converting...");
				convert();
				puts ("Conversion finished...\n");
				}

		DDfree();  /* release the DATAdesign engine */
		}
